using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Threading;
using System.Text;
using System.Windows.Forms;

namespace dNET_CS_Cache_Test
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        public uint Cycles;
        public double MaxTime, MinTime, AveTime, CacheTime;
        public int NTime;
        public double TTime;
        public const int NBigArray = 16 * 1024 * 1024;
        public List<Byte[]> DataList;
        

        private void button1_Click(object sender, EventArgs e)
        {
            Byte[] A = new Byte[NBigArray];
            for (int i = 0; i < NBigArray; i++) A[i] = 0;
            DataList.Add(A);
            int n = DataList.Count * NBigArray;
            textBox1.Text = n.ToString();
            Cycles = 0;
            textBox4.Text = "";
            textBox5.Text = "";
            if (SetWorkingSet.Checked)
            {
                Process currentProcess = Process.GetCurrentProcess();
                try
                {
                    currentProcess.MaxWorkingSet = (IntPtr)(NBigArray * DataList.Count + 2 * 1024 * 1024);
                    currentProcess.MinWorkingSet = (IntPtr)(NBigArray * DataList.Count + 2 * 1024 * 1024);
                }
                catch
                {
                    Memo1.Text = Memo1.Text + "SetProcessWorkingSetSize failure!\r\n";
                }
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (DataList.Count > 0)
            {
                DataList.RemoveAt(0);
            }
            // force garbage collection
            if (CollectGarbage.Checked) GC.Collect();
            int n = DataList.Count * NBigArray;
            textBox1.Text = n.ToString();
            Cycles = 0;
            textBox4.Text = "";
            textBox5.Text = "";
            if (SetWorkingSet.Checked)
            {
                Process currentProcess = Process.GetCurrentProcess();
                try
                {
                    currentProcess.MinWorkingSet = (IntPtr)(NBigArray * DataList.Count + 2 * 1024 * 1024);
                    currentProcess.MaxWorkingSet = (IntPtr)(NBigArray * DataList.Count + 2 * 1024 * 1024);
                }
                catch
                {
                    Memo1.Text = Memo1.Text + "SetProcessWorkingSetSize failure!\r\n";
                }
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            Memo1.Clear();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            MaxTime = 0.0;
            textBox4.Text = "";
        }

        private void button5_Click(object sender, EventArgs e)
        {
            CacheTime = 0.0;
            textBox5.Text = "";
        }

        private void SetWorkingSet_Click(object sender, EventArgs e)
        {
        }

        private void RunRealtime_Click(object sender, EventArgs e)
        {
            if (RunRealtime.Checked)
            {
                Process currentProcess = Process.GetCurrentProcess();
                currentProcess.PriorityClass = ProcessPriorityClass.RealTime;
                Thread currentThread = Thread.CurrentThread;
                currentThread.Priority = ThreadPriority.Highest;
            }
            else
            {
                Process currentProcess = Process.GetCurrentProcess();
                currentProcess.PriorityClass = ProcessPriorityClass.Normal;
                Thread currentThread = Thread.CurrentThread;
                currentThread.Priority = ThreadPriority.Normal;
            }
        }

        private void LockMemory_Click(object sender, EventArgs e)
        {
            // not possible in Win32
            Memo1.Text = Memo1.Text + "n/a\r\n";
        }

        private void Form1_Shown(object sender, EventArgs e)
        {
            DataList = new List<Byte[]>();
            textBox1.Text = "";
            textBox2.Text = "";
            textBox3.Text = "";
            textBox4.Text = "";
            textBox5.Text = "";
            Memo1.Clear();

            timer1.Enabled = true;

            Process currentProcess = Process.GetCurrentProcess();
            currentProcess.PriorityClass = ProcessPriorityClass.Normal;
            Thread currentThread = Thread.CurrentThread;
            currentThread.Priority = ThreadPriority.Normal;

            // can cause lockups, enable at your own risk
            //RunRealtime.Checked=false;
            //RunRealtime.Enabled=false;
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            timer1.Enabled = false;
            DataList.Clear();
        }

        public static bool InTimer = false;

        private void timer1_Tick(object sender, EventArgs e)
        {

            if (!InTimer)
            {
                InTimer = true;

                for (int i = 0; i < DataList.Count; i++)
                {
                    Stopwatch SW = Stopwatch.StartNew();
                    Byte[] BA = DataList[i];

                    for (int j = 0; j < NBigArray; j++)
                    {
                        BA[j++]++;
                        BA[j++]++;
                        BA[j++]++;
                        BA[j]++;
                    }
                    Cycles++;
                    SW.Stop();
                    textBox2.Text = Cycles.ToString() + "-" + i.ToString();
                    double T = SW.ElapsedMilliseconds * 0.001;
                    textBox3.Text = T.ToString();
                    uint SCycle = (uint)DataList.Count * 2;
                    if (Cycles == SCycle)
                    {
                        NTime = 0;
                        TTime = 0;
                        MinTime = 60.0;
                        MaxTime = 0.0;
                        AveTime = 0.0;
                        CacheTime = 0.0;
                    }
                    else if (Cycles > SCycle)
                    {
                        if (T > MaxTime)
                        {
                            MaxTime = T;
                            textBox4.Text = MaxTime.ToString();
                        }
                        if (T < MinTime) MinTime = T;
                        const int STime = 8;
                        if (NTime < STime)
                        {
                            NTime++;
                            TTime += T;
                            if (NTime == STime)
                            {
                                AveTime = TTime / NTime;
                            }
                        }
                        else
                        {
                            double ExcessTime = T - AveTime;
                            // more than 25% increase gets counted as excess time
                            if (ExcessTime > AveTime * 0.25)
                            {
                                CacheTime += ExcessTime;
                                textBox5.Text = CacheTime.ToString();
                            }
                        }
                    }
                }

                InTimer = false;
            }
        }
    }
}